Subject: Re: [PATCH] Pass --upload-pack and --receive-pack through submodules.

From: Jason Riedy <[email-masked]>
Date: Thu, 01 Jan 2009 20:44:03 -0500

And Junio C. Hamano writes:
> Do we (and can we) assume that the remote repositories submodules fetch
> from all reside on the same host and can share the same values for these
> parameters?  Shouldn't these instead be specified in the configuration
> files for the submodules, if they need to be nonstandard values?

git does not and (for me) should not make the assumption above.
I'm fetching different pieces from different administrative
domains where I also have push access.  While I could clone them
all into one place, that adds another level of repositories I'd
have to keep up-to-date.

Essentially, I'm collecting experimental libraries and drivers
into one build tree.  My intent is to record exactly what is
being built on multiple machines while being able to push local
build configurations back to my central superproject.  Then I can
make a version with pull-only remote URLs[1] for others to
duplicate the setup for my experiments.

I suppose I could clone the submodules by hand and then use git
submodule add.  But then I'll have to build the structure by hand
(with my own wrapper) everywhere I use the supermodule.  At that
point, using git submodule becomes a tad silly.  Or I could set
up the superproject with pull-only URLs and modify the
configurations with a separate wrapper.  Seemed like adding the
two options to git submodule was easier.

Jason

Footnotes: 
[1]  Or ask for separate pull- and push-urls in git remote.  But
I haven't thought that through.